Name: cockpit-tuna
Version: 0.10.2
Release: 1%{?dist}
Summary: Cockpit Tuna Module
License: LGPLv2+

Source0: https://github.com/cockpit-project/tuna/releases/download/%{version}/%{name}-%{version}.tar.xz
Source1: https://github.com/cockpit-project/tuna/releases/download/%{version}/%{name}-node-%{version}.tar.xz
BuildArch: noarch
ExclusiveArch: %{nodejs_arches} noarch
%if 0%{?fedora}
BuildRequires: nodejs-devel < 1:19
%endif
BuildRequires: nodejs
BuildRequires: make
BuildRequires: libappstream-glib
BuildRequires: gettext
BuildRequires: python3
BuildRequires: python3-devel
BuildRequires: python3-setuptools
%if 0%{?rhel} && 0%{?rhel} <= 8
BuildRequires: libappstream-glib-devel
%endif

%?python_enable_dependenct_generator

Obsoletes: cockpit-tuna-plugin <= %{version}

Requires: cockpit-bridge
Requires: python3 >= 3.7
Requires: python3-linux-procfs

%description
Cockpit Tuna Module

%prep
%autosetup -n %{name} -a 1
# ignore pre-built webpack in release tarball and rebuild it
# but keep it in RHEL/CentOS-8, as that has a too old nodejs
%if ! 0%{?rhel} || 0%{?rhel} >= 9
rm -rf dist
%endif

%build
pushd ./python-backend
%{python3} setup.py build
popd
ESLINT=0 NODE_ENV=production make

%install
pushd ./python-backend
%{python3} setup.py install --skip-build --root %{buildroot}
popd
%make_install PREFIX=/usr

# drop source maps, they are large and just for debugging
find %{buildroot}%{_datadir}/cockpit/ -name '*.map' | xargs --no-run-if-empty rm --verbose

%check
appstream-util validate-relax --nonet %{buildroot}/%{_datadir}/metainfo/*

# this can't be meaningfully tested during package build; tests happen through
# FMF (see plans/all.fmf) during package gating

%files
%doc README.md
%license LICENSE dist/index.js.LICENSE.txt.gz
%{_datadir}/cockpit/*
%{_datadir}/metainfo/*
%{python3_sitelib}/cockpit_tuna*

%changelog
* Wed Apr  5 2023 Guy Streeter <guy.streeter@gmail.com> (0.10-2)
- python 3.6 (centos 8) needs more keywords in setup.py

* Wed Apr  5 2023 Guy Streeter <guy.streeter@gmail.com> (0.10-1.2-2-gff84019)
- use python 3.6 syntax, for centos 8 compatibility

* Tue Apr  4 2023 Guy Streeter <guy.streeter@gmail.com> (0.10-1.2-1-g3635a07)
- get the python module build working

* Mon Apr  3 2023 Guy Streeter <guy.streeter@gmail.com> (0.10-1.2)
- correct package name

* Mon Apr  3 2023 Guy Streeter <guy.streeter@gmail.com> (0.10-1.1)
- buildreq setuptools

* Mon Apr  3 2023 Guy Streeter <guy.streeter@gmail.com> (0.10-1)
- Merge branch '3-make-the-backend-a-python-module' into 'main'Resolve "Make the backend a Python module"

Closes #3

See merge request guystreeter/cockpit-tuna!2

* Mon Apr  3 2023 Guy Streeter <guy.streeter@gmail.com> (0.9-2-1-g75003bf)
- Resolve "Make the backend a Python module"

* Mon Apr  3 2023 Guy Streeter <guy.streeter@gmail.com> (0.9-2)
- Merge branch '1-add-cpu-usage-overview-to-the-toolbar' into 'main'Resolve "Add CPU usage overview to the toolbar"

Closes #2 and #1

See merge request guystreeter/cockpit-tuna!1

* Sun Apr  2 2023 Guy Streeter <guy.streeter@gmail.com> (0.9-1-4-gd180653)
- add total CPU usage to the toolbar closes #1 #2 for merge request !1

* Sun Apr  2 2023 Guy Streeter <guy.streeter@gmail.com> (0.9-1-3-g89f38d6)
- move the refresh interval input to a Settings modal

* Wed Mar 29 2023 Guy Streeter <guy.streeter@gmail.com> (0.9-1-2-g4f99b80)
- update react version req

* Wed Mar 29 2023 Guy Streeter <guy.streeter@gmail.com> (0.9-1-1-gafb6251)
- Update the README

* Sun Mar 12 2023 Guy Streeter <guy.streeter@gmail.com> (0.9-1)
- work around a fedora packaging screw-up

* Sat Mar 11 2023 Guy Streeter <guy.streeter@gmail.com> (0.9)
- more tweaks to bitset display

* Wed Mar  8 2023 Guy Streeter <guy.streeter@gmail.com> (0.8-5-5-g8fe31b4)
- show cpu bitset as hex when it's complicates, range otherwise

* Tue Mar  7 2023 Guy Streeter <guy.streeter@gmail.com> (0.8-5-4-gc5bfd97)
- initial switch to using BitSet

* Tue Mar  7 2023 Guy Streeter <guy.streeter@gmail.com> (0.8-5-3-ge2bc812)
- checkboxes work

* Wed Feb 22 2023 Guy Streeter <guy.streeter@gmail.com> (0.8-5-2-g7edd683)
- use stylelint instead of vscode's linter

* Wed Feb 22 2023 Guy Streeter <guy.streeter@gmail.com> (0.8-5-1-g84eb8bf)
- npm stylelint and vscode stylelint can't agree on final newline

* Sun Feb 19 2023 Guy Streeter <guy.streeter@gmail.com> (0.8-5)
- code cleanup

* Sun Feb 19 2023 Guy Streeter <guy.streeter@gmail.com> (0.8-4-1-g4fce44d)
- try a more sane json structure for the topology

* Sat Feb 18 2023 Guy Streeter <guy.streeter@gmail.com> (0.8-4)
- fix a few linter complaints

* Sat Feb 18 2023 Guy Streeter <guy.streeter@gmail.com> (0.8-3-3-g6bfb96c)
- force the order of the cache boxes

* Sat Feb 18 2023 Guy Streeter <guy.streeter@gmail.com> (0.8-3-2-g9484dc5)
- more multi-socket fixes

* Sat Feb 18 2023 Guy Streeter <guy.streeter@gmail.com> (0.8-3-1-g3e0bfa8)
- fix (I hope) topology with multiple sockets

* Wed Feb 15 2023 Guy Streeter <guy.streeter@gmail.com> (0.8-3)
- stick to python 3.9 syntax

* Wed Feb 15 2023 Guy Streeter <guy.streeter@gmail.com> (0.8-2-1-ga2b8b7a)
- ignore pycache dir

* Wed Feb 15 2023 Guy Streeter <guy.streeter@gmail.com> (0.8-2)
- fix the constant topology update make the clearTimeout effect only run on unmount

* Wed Feb 15 2023 Guy Streeter <guy.streeter@gmail.com> (0.8-1-gdf46e63)
- correct a typo twek the topology display

* Wed Feb 15 2023 Guy Streeter <guy.streeter@gmail.com> (0.8)
- new CPU topology display, shows all the caches.

* Mon Feb 13 2023 Guy Streeter <guy.streeter@gmail.com> (0.7-8-1-g184701c)
- update copyright year

* Fri Jan 20 2023 Guy Streeter <guy.streeter@gmail.com> (0.7-8)
- more topology layout fiddling

* Fri Jan 20 2023 Guy Streeter <guy.streeter@gmail.com> (0.7-7-2-g1aee387)
- catch more "process went away" errors

* Wed Jan 18 2023 Guy Streeter <guy.streeter@gmail.com> (0.7-7-1-g4b99cf9)
- add ISO sched policy

* Wed Jan 18 2023 Guy Streeter <guy.streeter@gmail.com> (0.7-7)
- correct translation of policy to number

* Tue Jan 17 2023 Guy Streeter <guy.streeter@gmail.com> (0.7-6)
- remove debug print

* Tue Jan 17 2023 Guy Streeter <guy.streeter@gmail.com> (0.7-5-1-g23ecd8c)
- caches are per-socket, and we assume the same cache topology for all sockets.

* Mon Jan 16 2023 Guy Streeter <guy.streeter@gmail.com> (0.7-5)
- Stop refreshing if the user navigates away from the page.

* Sun Jan 15 2023 Guy Streeter <guy.streeter@gmail.com> (0.7-4)
- correct Obsoletes syntax

* Sun Jan 15 2023 Guy Streeter <guy.streeter@gmail.com> (0.7-3)
- versioned Obsoletes

* Sun Jan 15 2023 Guy Streeter <guy.streeter@gmail.com> (0.7-2)
- Make sure the new package will get install if the old package name is requested, and will install over the old package name.

* Sat Jan 14 2023 Guy Streeter <guy.streeter@gmail.com> (0.7-1)
- maintain good contrast between text and background in the topology even when the browser is in dark mode.

* Sat Jan 14 2023 Guy Streeter <guy.streeter@gmail.com> (0.7-1-g256b6cb)
- PU list needs unique keys

* Sat Jan 14 2023 Guy Streeter <guy.streeter@gmail.com> (0.7)
- rename tuna-plugin to tuna

* Mon Jan  9 2023 Guy Streeter <guy.streeter@gmail.com> (0.6-2)
- Keep the process-list toolbar displayed while the empty state message is displayed.

* Mon Jan  9 2023 Guy Streeter <guy.streeter@gmail.com> (0.6-1-1-g2c81c30)
- No need to check for local path in scripts

* Mon Jan  9 2023 Guy Streeter <guy.streeter@gmail.com> (0.6-1)
- don't use python schedutils (again)

* Mon Jan  9 2023 Guy Streeter <guy.streeter@gmail.com> (0.6)
- add the IRQ list tab

* Mon Jan  9 2023 Guy Streeter <guy.streeter@gmail.com> (0.5-1-4-g9014532)
- remove debugging

* Sat Dec 31 2022 Guy Streeter <guy.streeter@gmail.com> (0.5-1-3-gf07cb2b)
- use a 'danger' backgroud color for offline processors

* Fri Dec 30 2022 Guy Streeter <guy.streeter@gmail.com> (0.5-1-2-g95354bf)
- add an option to show full CPU topology

* Fri Dec 30 2022 Guy Streeter <guy.streeter@gmail.com> (0.5-1-1-g60e6246)
- put an alert on the page when the backend interaction fails only run the topology command once

* Thu Dec 29 2022 Guy Streeter <guy.streeter@gmail.com> (0.5-1)
- move buttons specific to the process list to their own toolbar put general buttons above the tabs

* Wed Dec 28 2022 Guy Streeter <guy.streeter@gmail.com> (0.5)
- massive re-factoring for support of the irq and cpu tabs breaking changes to the backend interface for same

* Tue Dec 27 2022 Guy Streeter <guy.streeter@gmail.com> (0.4)
- fix wrong full path to backend script re-factoring in preparation for irq and cpu pages

* Tue Dec 27 2022 Guy Streeter <guy.streeter@gmail.com> (0.3-3-6-gf957882)
- typo

* Tue Dec 27 2022 Guy Streeter <guy.streeter@gmail.com> (0.3-3-5-gc3ba79e)
- typo

* Tue Dec 27 2022 Guy Streeter <guy.streeter@gmail.com> (0.3-3-4-g3ec44af)
- Add backend support for reporting cpu topology and usage.

* Mon Dec 26 2022 Guy Streeter <guy.streeter@gmail.com> (0.3-3-3-gd14cfc7)
- typo

* Fri Dec 23 2022 Guy Streeter <guy.streeter@gmail.com> (0.3-3-2-gee1a167)
- Add supprt for reporting the CPU topology also, lint check fixes

* Fri Dec 23 2022 Guy Streeter <guy.streeter@gmail.com> (0.3-3-1-g267423e)
- cleaning up meta stuff

* Fri Dec 23 2022 Guy Streeter <guy.streeter@gmail.com> (0.3-3)
- Add tabs for IRQ and CPU displays. Required more scrolling fixes.

* Sun Dec 18 2022 Guy Streeter <guy.streeter@gmail.com> (0.3-2)
- separate files for separate high-level components

* Wed Dec 14 2022 Guy Streeter <guy.streeter@gmail.com> (0.3-1)
- a better name for the process update function

* Wed Dec 14 2022 Guy Streeter <guy.streeter@gmail.com> (0.3-0-3-g1223d77)
- typo

* Wed Dec 14 2022 Guy Streeter <guy.streeter@gmail.com> (0.3-0-2-g201b92c)
- skip one shallow copy

* Mon Dec 12 2022 Guy Streeter <guy.streeter@gmail.com> (0.3-0-1-g25c5f77)
- Don't allow de-selectiong both kernel and user threads

* Sun Dec 11 2022 Guy Streeter <guy.streeter@gmail.com> (0.3-0)
- Add selector buttons for showing kernel and/or user threads

* Sun Dec 11 2022 Guy Streeter <guy.streeter@gmail.com> (0.2-8-2-g4b3047b)
- For maintainability, be explicit about which values returned from the backend will be displayed in the process table, and in what order they will be displayed.

* Sun Dec 11 2022 Guy Streeter <guy.streeter@gmail.com> (0.2-8-1-g41f647f)
- right-align all but the last header teader text

* Sun Dec 11 2022 Guy Streeter <guy.streeter@gmail.com> (0.2-8)
- Proper scrollbars on the table, without hard-coding the height of the toolbar

* Fri Dec  9 2022 Guy Streeter <guy.streeter@gmail.com> (0.2-7-1-g42a2bee)
- more use of CSS for simplicity

* Thu Dec  8 2022 Guy Streeter <guy.streeter@gmail.com> (0.2-7)
- just trying to pretty it up a bit

* Wed Dec  7 2022 Guy Streeter <guy.streeter@gmail.com> (0.2-6)
- Scroll thre process table instead of the whole window. I don't like that I have to hard-code the toolbar height. There must be a better way.

* Mon Dec  5 2022 Guy Streeter <guy.streeter@gmail.com> (0.2-5-2-g380d099)
- added --pretty option to the backend to make the output easier to read for debugging

* Sun Dec  4 2022 Guy Streeter <guy.streeter@gmail.com> (0.2-5-1-g34f68a6)
- minor cleanups

* Sun Dec  4 2022 Guy Streeter <guy.streeter@gmail.com> (0.2-5)
- regular expression command filter

* Sat Dec  3 2022 Guy Streeter <guy.streeter@gmail.com> (0.2-4-1-g7a5374b)
- fill in the specfile changelog from git commits. (this means we need to use tags)

* Fri Dec  2 2022 Guy Streeter <guy.streeter@gmail.com> (0.2-4)
- filter the table while the user is typing the filter string.

* Mon Nov 28 2022 Guy Streeter <guy.streeter@gmail.com> (0.2-2)
- remove debugging

* Mon Nov 28 2022 Guy Streeter <guy.streeter@gmail.com> (0.2-1)
- add (simple) filtering on commandline

* Fri Nov 25 2022 Guy Streeter <guy.streeter@gmail.com> (0.2-2-g8ed9f1a)
- remove debugging

* Fri Nov 25 2022 Guy Streeter <guy.streeter@gmail.com> (0.2-1-g4e7f9d3)
- support turning refresh off and on from the toolbar

* Fri Nov 25 2022 Guy Streeter <guy.streeter@gmail.com> (0.2)
- BREAKING CHANGE: We already assume we know what the set of values returned from the backend is. No need for the header row.

* Fri Nov 25 2022 Guy Streeter <guy.streeter@gmail.com> (0.1-11-2-g7c35e09)
- reloading threads is necessary

* Fri Nov 25 2022 Guy Streeter <guy.streeter@gmail.com> (0.1-11-1-gb1e30fc)
- make showing threads always happen. no reason we should not

* Fri Nov 25 2022 Guy Streeter <guy.streeter@gmail.com> (0.1-11)
- State changes concerning the process list should be restricted to the table component. This keeps the rest of the page from re-rendering when the list updates.

* Sun Nov 20 2022 Guy Streeter <guy.streeter@gmail.com> (0.1-10-3-gfe296bb)
- I learned a thing call "optional chaining"

* Sat Nov 19 2022 Guy Streeter <guy.streeter@gmail.com> (0.1-10-2-g3ba6854)
- The latest advice from React is to use "functional elements" instead of classes. This gets a bit tricky, since in javascript all inner functions are closures. So, to access the current value of anyrhing in one of the inner functions, you pretty much have to pass it as a parameter to the function call.

* Fri Nov 18 2022 Guy Streeter <guy.streeter@gmail.com> (0.1-10-1-gdd8e904)
- a few comments

* Fri Nov 18 2022 Guy Streeter <guy.streeter@gmail.com> (0.1-10)
- convert the main Application class to a Functional Element (it's the latest craze)

* Wed Nov 16 2022 Guy Streeter <guy.streeter@gmail.com> (0.1-9)
- Get rid of the alternate-row sriping. It's visually confusing when a refresh adds a row above what we're looking at.

* Wed Nov 16 2022 Guy Streeter <guy.streeter@gmail.com> (0.1-8-3-gb1dd0b9)
- Give the child table rows the same top/bottom padding as the parent. Solution suggested by Michael Coker on Patternfly slack. Also restore the row borders, so we get that colored left border on the expanded rows.

* Tue Nov 15 2022 Guy Streeter <guy.streeter@gmail.com> (0.1-8-2-g36d7f48)
- add a loading spinner

* Tue Nov 15 2022 Guy Streeter <guy.streeter@gmail.com> (0.1-8-1-g1f6b027)
- I've discovered destructured props! They're cool!

* Tue Nov 15 2022 Guy Streeter <guy.streeter@gmail.com> (0.1-8)
- Now with threads! Expandable rows show the threads for ant process that has them. Also, renamed our custom components to help avoid conflicts

* Fri Nov 11 2022 Guy Streeter <guy.streeter@gmail.com> (0.1-7-1-g6dd2ae4)
- add thread info to the backend (not yet supported in the front end)

* Fri Nov 11 2022 Guy Streeter <guy.streeter@gmail.com> (0.1-7)
- fix our problem with the outer array converting to an Object

* Fri Nov 11 2022 Guy Streeter <guy.streeter@gmail.com> (0.1-6)
- better way to make room at the top for controls, etc.

* Thu Nov 10 2022 Guy Streeter <guy.streeter@gmail.com> (0.1-5-3-gfbdcc26)
- an attempt to parse and display CPU topology

* Mon Nov  7 2022 Guy Streeter <guy.streeter@gmail.com> (0.1-5-2-gbfeab86)
- typo

* Mon Nov  7 2022 Guy Streeter <guy.streeter@gmail.com> (0.1-5-1-g2a949ad)
- typo

* Mon Nov  7 2022 Guy Streeter <guy.streeter@gmail.com> (0.1-5)
- add room at the top for controls change the update delay to 3 seconds

* Sat Nov  5 2022 Guy Streeter <guy.streeter@gmail.com> (0.1-4)
- don't use python-schedutils

* Sat Nov  5 2022 Guy Streeter <guy.streeter@gmail.com> (0.1-3)
- requires, not buildrequires

* Sat Nov  5 2022 Guy Streeter <guy.streeter@gmail.com> (0.1-2-1-g5d933a7)
- the rpm needs schedutils and procfs

* Fri Nov  4 2022 Guy Streeter <guy.streeter@gmail.com> (0.1-2)
- try to keep from building with the local script path

* Fri Nov  4 2022 Guy Streeter <guy.streeter@gmail.com> (0.1-1-6-g5a277b1)
- use the path of the installed backend script

* Fri Nov  4 2022 Guy Streeter <guy.streeter@gmail.com> (0.1-1-5-gb89bda6)
- explain setting up local test/devel

* Fri Nov  4 2022 Guy Streeter <guy.streeter@gmail.com> (0.1-1-4-g12a4db9)
- need a README

* Fri Nov  4 2022 Guy Streeter <guy.streeter@gmail.com> (0.1-1-3-gb91e328)
- typo

* Fri Nov  4 2022 Guy Streeter <guy.streeter@gmail.com> (0.1-1-2-g3c183fc)
- dynamically setting the script location turn out to be an installation nightmare. need some other solution

* Fri Nov  4 2022 Guy Streeter <guy.streeter@gmail.com> (0.1-1-1-g4b37eaf)
- we'll need the backend script

* Fri Nov  4 2022 Guy Streeter <guy.streeter@gmail.com> (0.1-1)
- working process display

* Fri Nov  4 2022 Guy Streeter <guy.streeter@gmail.com> ()
- rename everything every where from "starter kit" to "tuna plugin" move README.md to starter-kit-README.md because we might need to refer to it later don't bother with po/* files since they will need to be regenerated

* Fri Nov  4 2022 Guy Streeter <guy.streeter@gmail.com> ()
- everything from the cockpit starter kit github at https://github.com/cockpit-project/starter-kit

